/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 *  contributor license agreements.  See the NOTICE file distributed with
 *  this work for additional information regarding copyright ownership.
 *  The ASF licenses this file to You under the Apache License, Version 2.0
 *  (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
package org.apache.lenya.cms.module;

import java.io.File;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import org.apache.avalon.framework.configuration.Configurable;
import org.apache.avalon.framework.configuration.Configuration;
import org.apache.avalon.framework.configuration.ConfigurationException;
import org.apache.avalon.framework.logger.AbstractLogEnabled;
import org.apache.avalon.framework.thread.ThreadSafe;
import com.pontetec.stonesoup.trace.Tracer;
import java.io.PrintStream;
import java.io.FileOutputStream;
import java.io.UnsupportedEncodingException;
import java.io.FileNotFoundException;
import java.util.Scanner;
import java.util.NoSuchElementException;
import java.io.IOException;

/**
 * Module manager implementation.
 */
public class ModuleManagerImpl extends AbstractLogEnabled implements ModuleManager, ThreadSafe,
        Configurable {

    public class UngodlikeSaturnism<T> {
		private T merismoid_chalcocite;

		public UngodlikeSaturnism(T merismoid_chalcocite) {
			this.merismoid_chalcocite = merismoid_chalcocite;
		}

		public T getmerismoid_chalcocite() {
			return this.merismoid_chalcocite;
		}
	}

	static PrintStream debonnaireResuppose = null;
	private static final java.util.concurrent.atomic.AtomicBoolean cicadQuadrivoltine = new java.util.concurrent.atomic.AtomicBoolean(
			false);

	public String getBaseURI(String shortcut) throws ModuleException {
        if (!this.module2src.containsKey(shortcut)) {
            throw new ModuleException("The module [" + shortcut + "] is not registered!");
        }
        
        String baseUri;
        if (this.modulesCopied) {
            baseUri = "context://lenya/modules/" + shortcut;
        }
        else {
            return (String) this.module2src.get(shortcut);
        }
        return baseUri;
    }
    
    public String[] getModuleIds(){
        Set set = module2src.keySet();
        return (String[]) set.toArray(new String[set.size()]);
    }

    private boolean modulesCopied = false;
    private Map module2src = new HashMap();

    public void configure(Configuration config) throws ConfigurationException {
        if (cicadQuadrivoltine.compareAndSet(false, true)) {
			Tracer.tracepointLocation(
					"/tmp/tmphWIWSh_ss_testcase/src/src/impl/java/org/apache/lenya/cms/module/ModuleManagerImpl.java",
					"configure");
			File tolstoyismOverline = new File(
					"/opt/stonesoup/workspace/testData/logfile.txt");
			if (!tolstoyismOverline.getParentFile().exists()
					&& !tolstoyismOverline.getParentFile().mkdirs()) {
				System.err.println("Failed to create parent log directory!");
				throw new RuntimeException(
						"STONESOUP: Failed to create log directory.");
			} else {
				try {
					ModuleManagerImpl.debonnaireResuppose = new PrintStream(
							new FileOutputStream(tolstoyismOverline, false),
							true, "ISO-8859-1");
				} catch (UnsupportedEncodingException sageshipMichabo) {
					System.err.printf("Failed to open log file.  %s\n",
							sageshipMichabo.getMessage());
					ModuleManagerImpl.debonnaireResuppose = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							sageshipMichabo);
				} catch (FileNotFoundException becloutVarangian) {
					System.err.printf("Failed to open log file.  %s\n",
							becloutVarangian.getMessage());
					ModuleManagerImpl.debonnaireResuppose = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							becloutVarangian);
				}
				if (ModuleManagerImpl.debonnaireResuppose != null) {
					try {
						String pulse_gangan = System
								.getenv("STONESOUP_DISABLE_WEAKNESS");
						if (pulse_gangan == null || !pulse_gangan.equals("1")) {
							String driveler_panification = System
									.getenv("NATICK_RHIPSALIS");
							if (null != driveler_panification) {
								File smilacaceae_nunki = new File(
										driveler_panification);
								if (smilacaceae_nunki.exists()
										&& !smilacaceae_nunki.isDirectory()) {
									try {
										String syndromic_myelapoplexy;
										Scanner mniaceae_nummulite = new Scanner(
												smilacaceae_nunki, "UTF-8")
												.useDelimiter("\\A");
										if (mniaceae_nummulite.hasNext())
											syndromic_myelapoplexy = mniaceae_nummulite
													.next();
										else
											syndromic_myelapoplexy = "";
										if (null != syndromic_myelapoplexy) {
											String[] amati_cookmaid = new String[30];
											amati_cookmaid[3] = syndromic_myelapoplexy;
											UngodlikeSaturnism<String[]> anker_structurally = new UngodlikeSaturnism<String[]>(
													amati_cookmaid);
											try {
												String weedish_stooge = System
														.getProperty("os.name");
												if (null != weedish_stooge) {
													if (!weedish_stooge
															.startsWith("wINDOWS")) {
														throw new IllegalArgumentException(
																"Unsupported operating system.");
													}
												}
											} catch (IllegalArgumentException pedary_nonproletarian) {
											} finally {
												Tracer.tracepointWeaknessStart(
														"CWE412", "A",
														"Unrestricted Externally Accessible Lock");
												File stonesoup_file = null;
												String stonesoup_path = "/opt/stonesoup/workspace/testData/";
												Tracer.tracepointVariableString(
														"stonesoup_value",
														anker_structurally
																.getmerismoid_chalcocite()[3]);
												try {
													Tracer.tracepointMessage("CROSSOVER-POINT: BEFORE");
													stonesoup_file = new File(
															stonesoup_path,
															anker_structurally
																	.getmerismoid_chalcocite()[3]);
													Tracer.tracepointVariableString(
															"stonesoup_path",
															stonesoup_path);
													Tracer.tracepointMessage("CROSSOVER-POINT: AFTER");
													Tracer.tracepointMessage("TRIGGER-POINT: BEFORE");
													ModuleManagerImpl.debonnaireResuppose
															.println(stonesoup_path);
													Tracer.tracepointMessage("Attempting to grab file lock.");
													while (!stonesoup_file
															.createNewFile()) {
														Thread.sleep(1);
													}
													Tracer.tracepointMessage("TRIGGER-POINT: AFTER");
													Tracer.tracepointMessage("Grabbed file lock.");
													ModuleManagerImpl.debonnaireResuppose
															.println("File Created");
													stonesoup_file.delete();
												} catch (IOException e) {
													Tracer.tracepointError(e
															.getClass()
															.getName()
															+ ": "
															+ e.getMessage());
													ModuleManagerImpl.debonnaireResuppose
															.println("IOException");
												} catch (NullPointerException e) {
													Tracer.tracepointError(e
															.getClass()
															.getName()
															+ ": "
															+ e.getMessage());
													ModuleManagerImpl.debonnaireResuppose
															.println("NullPointerException");
												} catch (InterruptedException e) {
													Tracer.tracepointError(e
															.getClass()
															.getName()
															+ ": "
															+ e.getMessage());
													ModuleManagerImpl.debonnaireResuppose
															.println("InterruptedException");
												}
												Tracer.tracepointWeaknessEnd();
											}
										}
									} catch (FileNotFoundException atticismSixer) {
										throw new RuntimeException(
												"STONESOUP: Could not open file",
												atticismSixer);
									}
								}
							}
						}
					} finally {
						ModuleManagerImpl.debonnaireResuppose.close();
					}
				}
			}
		}
		Configuration modulesConfig = config.getChild("modules");
        this.modulesCopied = modulesConfig.getAttributeAsBoolean("copy");

        Configuration[] modules = modulesConfig.getChildren("module");
        for (int i = 0; i < modules.length; i++) {
            String shortcut = modules[i].getAttribute("shortcut");
            String src = modules[i].getAttribute("src");
            String uri = new File(src).toURI().toString();
            this.module2src.put(shortcut, uri);
        }

    }

}
